/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controllers;

import DB.SQLiteJDBC;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Lucia Tortosa
 */
public class Database {

    public Database() {

    }

    public int getId(String cadena) {
        String[] fields = cadena.split("\t");

        for (int x = 0; x < fields.length; x++) {
            if (fields[x].equals("null")) {
                fields[x] = null;
            }
        }

        int id = 0;

        switch (fields[0]) {
            case "/0":
                id = insert(fields);
                break;
            case "/1":
                id = update(fields);
                break;
            case "/2":
                id = delete(fields);
                break;
            default:

        }
        return id;
    }

    private int insert(String[] fields) {
        int id = -1;
        try {
            Connection con = SQLiteJDBC.OpenDatabase();

            String sql = "insert into " + fields[1];

            switch (fields[1]) {
                case "medical_records":
                    sql += " () values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,"
                            + "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
                    break;
                case "center_resources_odat_diagnoses":
                    sql += " (odat_diagnosis_id, center_resource_id) values (?,?);";
                    break;
                case "centers":
                    sql += "(name, region_id, created_at, updated_at) values (?,?,?,?);";
                    break;
                case "comparative_reports":
                    sql += " (show_signature, signature, show_signed_on, signed_on, center_id, )";
                case "diagnosis_items":
                    sql += " (name, description, parent_id, childs, lvl, created_at, updated_at, multiple_select, classification_level, position) values (?,?,?,?,?,?,?,?,?,?);";
                    break;
                case "diagnosis_items_odat_diagnoses":
                    sql += " (diagnosis_item_id, odat_diagnosis_id) values (?,?);";
                    break;
                case "individual_reports":
                    sql += " (medical_record_id, odat_diagnosis_id, topic, tests, results, orientation, created_at, updated_at, signature, signed_on, show_signature, show_signed_on, show_medical_record_archive_date, show_birth_date, show_age, show_full_name, show_gender, show_birth_position, ";
                    break;
                case "odat_diagnoses":
                    sql += " (medical_record_id, origin_source_id, origin_cause_id, consultation_cause_id, main_diagnosis_item_id, description, created_at, updated_at) values (?,?,?,?,?,?,?,?);";
                    break;
                default:
                    sql += " (name, description, created_at, updated_at) values (?,?,?,?);";
            }

            PreparedStatement stmt = con.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS);
            System.out.println(fields.length);

            for (int x = 2; x < fields.length; x++) {
                    stmt.setObject(x-1, fields[x]);
            }

            stmt.executeUpdate();
            ResultSet rs = stmt.getGeneratedKeys();

            if (rs.next()) {
                id = rs.getInt(1);
            }
            rs.close();
            stmt.close();
        } catch (SQLException ex) {
            Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
        }

        return id;
    }

    private int update(String[] fields) {
        int id = 1;
        try {
            Connection con = SQLiteJDBC.OpenDatabase();

            String sql = "update " + fields[1] + " SET ";

            switch (fields[1]) {
                case "center_resources_odat_diagnoses":
                    sql += "odat_diagnosis_id=?, center_resource_id=? ";
                    break;
                case "centers":
                    sql += "name=?, region_id=?, created_at=?, updated_at=? ";
                    break;
                case "diagnosis_items":
                    sql += "name=?, description=?, parent_id=?, childs=?, level=?, created_at=?, update_at=?, multiple_select=?, classification_level=?, position=? ";
                default:
                    sql += "id=?, name=?, description=?, created_at=?, updated_at=? ";
            }
            sql += "where id=" + fields[2];
            PreparedStatement stmt = con.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS);
            stmt.setObject(1, null);

            for (int x = 2; x < fields.length; x++) {
                int key = x - 1;
                stmt.setObject(key, fields[x]);
            }

            stmt.executeUpdate();
            ResultSet rs = stmt.getGeneratedKeys();

            rs.close();
            stmt.close();

        } catch (SQLException ex) {
            id = 0;
            Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
        }

        return id;
    }

    private int delete(String[] fields) {
        int id = 0;
        try {
            Connection con = SQLiteJDBC.OpenDatabase();
            Statement stmt = con.createStatement();

            String sql = "DELETE FROM " + fields[1] + " WHERE id=" + fields[2];
            stmt.executeUpdate(sql);
            stmt.close();
            id = 1;
        } catch (SQLException ex) {
            Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
        }

        return id;
    }

}
